<?php

namespace Wechat\Work\Message;

abstract class MessageInterface
{
    const TYPE_TEXT = 'text';
    const TYPE_IMAGE = 'image';
    const TYPE_VOICE = 'voice';
    const TYPE_VIDEO = 'video';
    const TYPE_FILE = 'file';
    const TYPE_TEXT_CARD = 'textcard';
    const TYPE_NEWS = 'news';
    const TYPE_MP_NEWS = 'mpnews';

    protected $type;
    protected $attr;
    protected $safe;

    protected $params;

    abstract public function toArray();

    public function ofAgent($agentId)
    {
        $this->params['agentid'] = $agentId;
        return $this;
    }

    public function toUser($user)
    {
        $this->params['touser'] = $user;
        return $this;
    }

}